package com.gxwebsoft.common.system.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.ChatMessageService;
import com.gxwebsoft.common.system.entity.ChatMessage;
import com.gxwebsoft.common.system.param.ChatMessageParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * 聊天消息表控制器
 *
 * @author 科技小王子
 * @since 2024-04-27 15:57:27
 */
@Tag(name = "聊天")
@RestController
@RequestMapping("/api/system/chat-message")
public class ChatMessageController extends BaseController {
    @Resource
    private ChatMessageService chatMessageService;

    @Operation(summary = "分页查询聊天消息表")
    @GetMapping("/page")
    public ApiResult<PageResult<ChatMessage>> page(ChatMessageParam param) {
        // 使用关联查询
        return success(chatMessageService.pageRel(param));
    }

    @Operation(summary = "查询全部聊天消息表")
    @GetMapping()
    public ApiResult<List<ChatMessage>> list(ChatMessageParam param) {
        User loginUser = getLoginUser();
        param.setToUserId(loginUser.getUserId());
        return success(chatMessageService.listRel(param));
    }

    @Operation(summary = "根据id查询聊天消息表")
    @GetMapping("/{id}")
    public ApiResult<ChatMessage> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(chatMessageService.getByIdRel(id));
    }

    @Operation(summary = "添加聊天消息表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ChatMessage chatMessage) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          chatMessage.setFormUserId(loginUser.getUserId());
          if (chatMessageService.save(chatMessage)) {
            return success("添加成功");
          }
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:chatMessage:update')")
    @Operation(summary = "修改聊天消息表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ChatMessage chatMessage) {
        if (chatMessageService.updateById(chatMessage)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:chatMessage:remove')")
    @OperationLog
    @Operation(summary = "删除聊天消息表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (chatMessageService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @Operation(summary = "批量添加聊天消息表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ChatMessage> list) {
      final ArrayList<ChatMessage> saveData = new ArrayList<>();
      list.forEach(d -> {
          d.setFormUserId(getLoginUserId());
          saveData.add(d);
        });
        if(!saveData.isEmpty()){
          if (chatMessageService.saveBatch(saveData)) {
            return success("发送成功");
          }
        }
        return fail("发送失败");
    }

    @PreAuthorize("hasAuthority('sys:chatMessage:update')")
    @Operation(summary = "批量修改聊天消息表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ChatMessage> batchParam) {
        if (batchParam.update(chatMessageService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:chatMessage:remove')")
    @Operation(summary = "批量删除聊天消息表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (chatMessageService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
